angular.module('action').controller("SetPropertyAction", function ($scope, i18nService, definitionService, profileService) {

    function processData(data) {
        if ($scope.propertyAction.storeInSession == 'true') {
            $scope.sessionProperties = data;
        } else {
            $scope.profileProperties = data;
        }
        data.forEach(function(prop) {
            prop.metadata.id = "properties." + prop.metadata.id;
        });
        data.push({metadata:{id:'user-specified-property',name:i18nService.message('action.setPropertyAction.other')},type:'string',multivalued: false});

        initPropertyChoice();
    }

    function initPropertyChoice() {
        $scope.propertyAction.propertyNameChoiceListValues = $scope.propertyAction.storeInSession == 'true' ? $scope.sessionProperties : $scope.profileProperties;
        if (!$scope.propertyAction.propertyNameChoiceListValues) {
            if ($scope.propertyAction.storeInSession == 'true') {
                profileService.getPropertyTypesByTag("sessionProperties", true).success(processData);
            } else {
                profileService.getPropertyTypesByTag("profileProperties", true).success(processData);
            }
            return;
        }

        propertyNameChoiceListValuesIds = [];
        $scope.propertyAction.propertyNameChoiceListValues.forEach(function(prop) {
            if (prop.metadata.id.indexOf("properties.") == 0) {
                propertyNameChoiceListValuesIds.push(prop.metadata.id);
            }
        });


        $scope.propertyAction.predefinedProperty = $scope.ref.parameterValues.setPropertyName == null || $scope.ref.parameterValues.setPropertyName.length == 0 || propertyNameChoiceListValuesIds.indexOf($scope.ref.parameterValues.setPropertyName) > -1;
        if ($scope.propertyAction.predefinedProperty) {
            $scope.propertyAction.selectedPropertyName = $scope.ref.parameterValues.setPropertyName;
        } else {
            $scope.propertyAction.selectedPropertyName = 'user-specified-property';
        }
    }

    $scope.propertyAction = {};
    $scope.propertyAction.storeInSession = '' + ($scope.ref.parameterValues.storeInSession != null && $scope.ref.parameterValues.storeInSession);

    initPropertyChoice();

    $scope.$watch("propertyAction.selectedPropertyName", function (newValue, oldValue) {
        if (angular.isDefined(oldValue) && newValue != oldValue) {
            $scope.propertyAction.predefinedProperty = $scope.propertyAction.selectedPropertyName != 'user-specified-property';
            $scope.ref.parameterValues.setPropertyName = $scope.propertyAction.predefinedProperty ? $scope.propertyAction.selectedPropertyName : '';
        }
    });
    $scope.$watch("propertyAction.storeInSession", function (newValue, oldValue) {
        if (angular.isDefined(oldValue) && newValue != oldValue) {
            $scope.ref.parameterValues.storeInSession = $scope.propertyAction.storeInSession == 'true';
            initPropertyChoice();
        }
    });

});
