var dtPagerModule = angular.module('dtPager', ['i18n']);

dtPagerModule.service('dtPagerService', ['$timeout', 'i18nService', function($timeout, i18nService) {
    this.refreshPager = function ($scope) {
        $timeout(function () {
            ManagersUtils.initPagerProperties($scope.dtInstance.DataTable, $scope, i18nService);
            // need to call $scope.$digest to force variable link of the pager when reordering.
            if (!$scope.$$phase) {
                $scope.$digest();
            }
        });
    };
}]);

dtPagerModule.directive('dtPager', ['dtPagerService', function (dtPagerService) {
    return {
        restrict: 'E',
        templateUrl: ManagersContext.localTemplatesPath + '/dt-pager.html',
        controller: function($scope) {

            $(document).on('length.dt', function (event) {
                dtPagerService.refreshPager($scope);
            });

            $scope.$watch('dtInstance', function (val) {
                if (val) {
                    dtPagerService.refreshPager($scope);
                }
            });
        }
    }
}]);